#!/bin/zsh

declare -A _GET
declare -A _POST


cgi_get() {  # parse HTTP GET string
  echo "$QUERY_STRING" |tr '&' '\n' |while read query; do
    key="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\1:')"
    val="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\2:')"
    _GET["$key"]="$(echo -e "$(echo "$val" |sed 's:+: :g;s:%:\\x:g')")"
  done
  debug "$_GET"
}

cgi_post() {  # parse HTTP POST string
  sed -u 1q |tr '&' '\n' |while read query; do
    key="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\1:')"
    val="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\2:')"
    _POST["$key"]="$(echo -e "$(echo "$val" |sed 's:+: :g;s:%:\\x:g')")"
  done
  debug "$_POST"
}
